import Data.List
import Data.Maybe
import Glue

convertSingle :: Bool -> [[Bool]]
convertSingle True =
  [ [False, True , False]
  , [True , False, True ]
  , [False, True , False]
  ]
convertSingle False =
  [ [False, False, False]
  , [False, False, False]
  , [False, False, False]
  ]

diagToOrth :: [[Bool]] -> [[Bool]]
diagToOrth = concatMap (map concat . transpose) . map (map convertSingle)

canSolve :: [[Bool]] -> Bool
canSolve g = isJust res
  where orth = diagToOrth g
        res :: Maybe [Int]
        res = glueCall "r2.go" $ "entry([]bool{" ++ intercalate "," (map (\x -> case x of True -> "true"; False -> "false") . concat $ orth) ++ "}," ++ show (length orth) ++ ")"
