const std = @import("std");
const glue = @import("glue.zig");
const byte = u7;

pub fn entry(flat_cards: []const u7, calls: []const u7) usize {
    const cards: []const [5][5]u7 = @ptrCast([*]const [5][5]u7, flat_cards.ptr)[0..flat_cards.len/25];

    var arena = std.heap.ArenaAllocator.init(std.heap.page_allocator);
    defer arena.deinit();
    const allocator = arena.allocator();

    for (cards) |card, i| {
        blk: {
            const file = std.fs.cwd().createFile("progress", .{.truncate = false}) catch break :blk;
            defer file.close();
            file.writer().print("{:0>2}/{:0>2}\n", .{i, cards.len}) catch {};
        }
        // not doing this formatting shit again
        var out = std.fmt.allocPrint(allocator, "hasWon({any}, {any})", .{card, calls}) catch unreachable;
        for (out) |x, j| {
            out[j] = switch (x) {
                '{' => '[',
                '}' => ']',
                else => x,
            };
        }
        if (glue.glueCall(bool, "haswon.d", out, allocator)) {
            return i;
        }
    }
    unreachable;
}
