const std = @import("std");

pub fn glueCall(comptime T: type, file: []const u8, expr: []const u8, allocator: std.mem.Allocator) T {
    const result = std.ChildProcess.exec(.{
        .allocator = allocator,
        .argv = &.{"raku", "gluebus.raku", file, expr},
    }) catch unreachable;
    defer {
        allocator.free(result.stdout);
        allocator.free(result.stderr);
    }
    return std.json.parse(T, &std.json.TokenStream.init(result.stdout), .{ .allocator = allocator }) catch unreachable;
}
