import Data.Char
import Data.Maybe
import Parsing

termOp :: Parser (Int -> Int -> Int)
termOp = (*) <$ char '*' <|> div <$ char '/'

sumOp :: Parser (Int -> Int -> Int)
sumOp = (+) <$ char '+' <|> (-) <$ char '-'

term :: Parser Int
term = chainl1 (digitToInt <$> digit) termOp

expr :: Parser Int
expr = chainl1 term sumOp

entry :: String -> Int
entry = snd . fromJust . runParser (expr <* eof)
